import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    int redlevel;
    int bluelevel;
    public static int squares;
    public static int booms;
    public static int getbooms;
    public static int fullboom;
    public static int fb;
    
    public Player()
    {
        redlevel = 0;
        bluelevel = 0;
        squares = 0;
        booms = 0;
        getbooms = 0;
        fullboom = 0;
        fb = 0;
        
    }
    
    
 
    public void act() 
    {
        // Add your action code here.
        move();
        addRedSquare();
        addBlueSquare();
        redAten();
        blueAten();
        shot();
        addTarget();
        changeSkin();
        addBoom();
        boomAten();
        useBoom();
        updateScore();
        
    }  
    
     public void updateScore()
     {
        String txt = String.valueOf(MyWorld.score);
        World world;
        world = getWorld();
        world.showText("Your Score:" + txt,900,30);
    }
   
    
    
    public void move()
    {
        if(Greenfoot.isKeyDown("left"))
        {
            move(-5);            
        }
        if(Greenfoot.isKeyDown("right"))
        {
            move(5);
        }
        if(Greenfoot.isKeyDown("up"))
        {
            turn(-90);
            move(5);
            turn(90);
        }
        if(Greenfoot.isKeyDown("down"))
        {
            turn(-90);
            move(-5);
            turn(90);                    
        }
    }
    
  
    public void addTarget()
    {  
        int num = Greenfoot.getRandomNumber(100);
        if(num>=98)
        {
            Target target = new Target();
            int x = 300 + Greenfoot.getRandomNumber(1000-400);
            int y = 10 + Greenfoot.getRandomNumber(600-20);
            World world;
            world = getWorld();
            world.addObject(target,x,y);
        }
    }
    
    
    public void addRedSquare()
    {
       int num = Greenfoot.getRandomNumber(1000);
       if(num>=991)
        {
            Redup redup = new Redup();
            int x = 500 + Greenfoot.getRandomNumber(1000-500);
            int y = 20 + Greenfoot.getRandomNumber(600-40);
            
      
            World world;
            world = getWorld();
            if(squares<2)
            {
                world.addObject(redup,x,y);
                squares = squares + 1;
            }
            
        }
        
    }
    
     public void addBlueSquare()
    {
       int num = Greenfoot.getRandomNumber(1000);
       if(num>=991)
        {
            Blueup blueup = new Blueup();
            int x = 500 + Greenfoot.getRandomNumber(1000-500);
            int y = 20 + Greenfoot.getRandomNumber(600-40);
            
      
            World world;
            world = getWorld();
            if(squares<2)
            {
                world.addObject(blueup,x,y);
                squares =squares + 1;
            }
            
        }
        
    }
    
     
    public void addBoom()
    {
       int num = Greenfoot.getRandomNumber(1000);
       if(num>=990)
        {
            Boom boom = new Boom();
            int x = 500 + Greenfoot.getRandomNumber(1000-500);
            int y = 20 + Greenfoot.getRandomNumber(600-40);
            
      
            World world;
            world = getWorld();
            if(booms<1)
            {
                world.addObject(boom,x,y);
                booms =booms + 1;
            }
            
        }
        
    }
    
    public void boomAten()
    {
      
           Actor actor = getOneObjectAtOffset(0,0,Boom.class);
           if(actor != null)
           {
                if(fullboom<3)
                {
                    World world;
                    world = getWorld();
                    world.removeObject(actor);
                    getbooms = getbooms + 1;
                    
                    Timer timer = new Timer();
                    world.addObject(timer,50+25*getbooms,560);
                    fb = 0;
                    booms = booms - 1;
                    fullboom = fullboom + 1;
                }
           }
       
    }
    
    
    
    
    public void redAten()
    {
      
           Actor actor = getOneObjectAtOffset(0,0,Redup.class);
           if(actor != null)
           {
                World world;
                world = getWorld();
                world.removeObject(actor);
                redlevel = redlevel + 1;
                bluelevel = 0;
                squares = squares - 1;
           }
       
    }
    
    public void blueAten()
    {
       
        Actor actor = getOneObjectAtOffset(0,0,Blueup.class);
        if(actor != null)
        {
             World world;
             world = getWorld();
             world.removeObject(actor);
             bluelevel = bluelevel + 1;
             redlevel = 0;
             squares = squares - 1;
        }
       
    }
    
    public void changeSkin()
    {
        
        if(Greenfoot.isKeyDown("c"))
        {
           setImage("chinaskin.png");
        }
        if(Greenfoot.isKeyDown("g"))
        {
            setImage("goldenskin.png");
        }
        if(Greenfoot.isKeyDown("o"))
        {
            setImage("orginalskin.png");
        }
        
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public void shot()
    {
        if("space".equals(Greenfoot.getKey()))
        {
            Greenfoot.playSound("shot.mp3");
            int x = getX() + 50;
            int y = getY();
            World world;
            world = getWorld();
            Bullet bullet = new Bullet(8,8,0);
            world.addObject(bullet,x,y);
            if(redlevel == 1)
            {
                Bullet bullet1 = new Bullet(8,8,0);
                world.addObject(bullet1,x,y-15);
                Bullet bullet2 = new Bullet(8,8,0);
                world.addObject(bullet2,x,y);
                Bullet bullet3 = new Bullet(8,8,0);
                world.addObject(bullet3,x,y+15);
                bluelevel = 0;
            }
            if(redlevel == 2)
            {
                Bullet bullet1 = new Bullet(8,8,0);
                world.addObject(bullet1,x,y-15);
                Bullet bullet4 = new Bullet(8,8,0);
                world.addObject(bullet4,x,y-30);
                Bullet bullet2 = new Bullet(8,8,0);
                world.addObject(bullet2,x,y);
                Bullet bullet5 = new Bullet(8,8,0);
                world.addObject(bullet5,x,y+30);
                Bullet bullet3 = new Bullet(8,8,0);
                world.addObject(bullet3,x,y+15);
                bluelevel = 0;
            }
           
            if(redlevel >= 3)
            {
                Bullet bullet1 = new Bullet(8,8,0);
                world.addObject(bullet1,x,y-15);
                Bullet bullet4 = new Bullet(8,8,0);
                world.addObject(bullet4,x,y-30);
                Bullet bullet6 = new Bullet(8,8,0);
                world.addObject(bullet6,x,y-45);
                Bullet bullet2 = new Bullet(8,8,0);
                world.addObject(bullet2,x,y);
                Bullet bullet7 = new Bullet(8,8,0);
                world.addObject(bullet7,x,y+45);
                Bullet bullet5 = new Bullet(8,8,0);
                world.addObject(bullet5,x,y+30);
                Bullet bullet3 = new Bullet(8,8,0);
                world.addObject(bullet3,x,y+15);
                bluelevel = 0;
            }
           
            if(bluelevel == 1)
            {
                Bullet bullet1 = new Bullet(8,8,22);
                world.addObject(bullet1,x,y);
                Bullet bullet2 = new Bullet(8,8,0);
                world.addObject(bullet2,x,y);
                Bullet bullet3 = new Bullet(8,8,-22);
                world.addObject(bullet3,x,y);
                redlevel = 0;
            }
            
            if(bluelevel == 2)
            {
                Bullet bullet1 = new Bullet(8,8,38);
                world.addObject(bullet1,x,y);
                Bullet bullet4 = new Bullet(8,8,22);
                world.addObject(bullet4,x,y);
                Bullet bullet2 = new Bullet(8,8,0);
                world.addObject(bullet2,x,y);
                Bullet bullet5 = new Bullet(8,8,-22);
                world.addObject(bullet5,x,y);
                Bullet bullet3 = new Bullet(8,8,-38);
                world.addObject(bullet3,x,y);
                redlevel = 0;
            }
            
            if(bluelevel >= 3)
            {
                Bullet bullet1 = new Bullet(8,8,52);
                world.addObject(bullet1,x,y);
                Bullet bullet4 = new Bullet(8,8,38);
                world.addObject(bullet4,x,y);
                Bullet bullet6 = new Bullet(8,8,22);
                world.addObject(bullet6,x,y);
                Bullet bullet2 = new Bullet(8,8,0);
                world.addObject(bullet2,x,y);
                Bullet bullet7 = new Bullet(8,8,-22);
                world.addObject(bullet7,x,y);
                Bullet bullet5 = new Bullet(8,8,-38);
                world.addObject(bullet5,x,y);
                Bullet bullet3 = new Bullet(8,8,-52);
                world.addObject(bullet3,x,y);
                redlevel = 0;
            }
            
            //Greenfoot.playSound("shotsound.wav");
        }
    }
    
    
    
    
    
    public void useBoom()
    {
        if(Greenfoot.isKeyDown("b"))
        {
            
            if(Player.getbooms<=0)
            {
            }
            if(Player.getbooms>0)
            {
                //Greenfoot.playSound("Hongzha.wav");
                fire();
                
                fb = 1;
                Player.getbooms = 0;
            }
            
        }
    }
    
    
    public void fire()
    {
        
        if(Player.fullboom == 1)
        {
             
             for(int i = 0;i<15;i++)
             {
                World world;
                world = getWorld();
                Bigkill bigkill1 = new Bigkill();
                world.addObject(bigkill1,90,300+20*i);
                Bigkill bigkill2 = new Bigkill();
                world.addObject(bigkill2,90,300-20*i);
            
             }
             Player.fullboom = 0;
            
                    
        }
        if(Player.fullboom == 2)
        {
            for(int j = 0;j<2;j++)
            {
                for(int i = 0;i<15;i++)
                 {
                    World world;
                    world = getWorld();
                    Bigkill bigkill1 = new Bigkill();
                    world.addObject(bigkill1,90-30*j,300+20*i);
                    Bigkill bigkill2 = new Bigkill();
                    world.addObject(bigkill2,90-30*j,300-20*i);
                
                 }        
            }
            
            Player.fullboom = 0;
            
                    
                    
        }
        if(Player.fullboom == 3)
        {
            for(int j = 0;j<3;j++)
            {
                for(int i = 0;i<15;i++)
                 {
                    World world;
                    world = getWorld();
                    Bigkill bigkill1 = new Bigkill();
                    world.addObject(bigkill1,90-30*j,300+20*i);
                    Bigkill bigkill2 = new Bigkill();
                    world.addObject(bigkill2,90-30*j,300-20*i);
                
                 }        
            }
                    
             Player.fullboom = 0;
        }
    
    }
}

